#TEMPLATE(Headersort,' Terrys Header Sort Routines - Version 1.0'),FAMILY('CW20'),FAMILY('ABC')
#EXTENSION(ListBoxSortGlobal, 'Activate The ListBox Sort Class/Template For This Application'),APPLICATION
!
! Check for loading the global include.
!
#TAB ('Activate')
  #DISPLAY('')
  #DISPLAY('Activate ListBox Sort Templates')
  #DISPLAY('')
  #DISPLAY('*Warning* - Using The ListBox Sort Templates Without')
  #DISPLAY(' Activating The Global Template May Cause The Program')
  #DISPLAY(' Compile To Fail.')
  #DISPLAY('')
  #PROMPT('Activate ListBox Template', check), %ActiveIn, DEFAULT(1), AT(5)
#ENDTAB
#AT(%AfterGlobalIncludes)
#IF(%ActiveIn = 1)
Include('HeaderSort.inc'), Once
#ENDIF
#ENDAT
!
#EXTENSION(ListBoxSorting, 'Sort Listbox by double-clicking on the column header'),PROCEDURE ,multi
!
! Display options for the header sort
!
#TAB ('General')
  #DISPLAY('')
  #DISPLAY(' List Box Header Sort')
  #DISPLAY('')
  #PROMPT('Ascending Sort Marker:', @s20), %SortAscIn, DEFAULT('-A')
  #PROMPT('Descending Sort Marker:', @s20), %SortDescIn, DEFAULT('-D')
  #PROMPT('Primary Sort Field:', @n3), %SortPriFieldIn, DEFAULT(1)
  #DISPLAY('Primary Sort Order:') 
  #PROMPT('(+ = Asc., - = Desc.):', @s1), %SortPriOrderIn, DEFAULT('+')
  #PROMPT('Save Sorts', check), %SortSaveIn, DEFAULT(1)
  #PROMPT('Restore Format Option', check), %RestoreFormatIn, DEFAULT(1)
  #DISPLAY('')
  #DISPLAY('Select Listboxes To Be Used With This Template')
  #PROMPT('list boxes',FROM(%Control, %ControlType = 'LIST')), %CheckList, SELECTION('Choose Listboxes For Template')
  #DISPLAY('')
  #DISPLAY('*Warning* - Using The ListBox Sort Templates Without')
  #DISPLAY(' Activating The Global Template May Cause The Program')
  #DISPLAY(' Compile To Fail.')
  #DISPLAY('')
#ENDTAB
!
!  Create the headersort class for each table on the window
!
#AT(%DataSectionBeforeWindow)
#DECLARE(%ListPre)
  #FOR (%Control), WHERE(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
%ListPre  HeaderSortClass
  #ENDIF
  #ENDFOR
#ENDAT
!
!  Initialize the headersort for the tables
!
#AT(%AfterWindowOpening), PRIORITY(10000)
  #FOR (%Control),WHERE(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  %ListPre.Init(%Control, %ControlFrom, '%SortAscIn', '%SortDescIn', %SortPriFieldIn, '%SortPriOrderIn', %SortSaveIn)
  %ListPre.LoadSort(%Control, %ControlFrom, '%Procedure%ListPre')
  #IF(%RestoreFormatIn <> 1 )
  %ListPre.SetRestoreFlag(False)
  #ENDIF
  #ENDIF
  #ENDFOR
#ENDAT
!
!  Save the sort for the table to be restored next time
!
#AT(%BeforeWindowClosing), Priority(10000)
  #FOR (%Control),WHERE(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  %ListPre.SaveSort(%Control, %ControlFrom, '%Procedure%ListPre')
  #ENDIF
  #ENDFOR
#ENDAT
!
!  Set the different keys to be captured by the list table
!
#AT(%PrepareAlerts),LAST
  #FOR (%Control),WHERE(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  %Control{Prop:Imm}       = True
  %Control{Prop:Alrt, 255} = MouseLeft2
  %Control{Prop:Alrt, 254} = EscKey
  %Control{Prop:Alrt, 253} = DeleteKey
  %Control{Prop:Alrt, 252} = BSKey
  %Control{Prop:Alrt, 251} = MouseRight
  %Control{Prop:Alrt, 251} = HomeKey
  #ENDIF
  #ENDFOR
#ENDAT
!
!  Process any alert keys that have been pressed.
!
#AT(%ControlPreEventHandling, %Control, 'AlertKey')
  #IF(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  %ListPre.ListAlert(%Control, %ControlFrom)
  #ENDIF
  #ENDIF
#ENDAT
!
!  Process a new selection by reading the queue.
!
#AT(%ControlPreEventHandling, %Control, 'NewSelection')
  #IF(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  Get(%ControlFrom, Choice(%Control))
  #ENDIF
  #ENDIF
#ENDAT
!
!  Page down the list
!
#AT(%ControlPreEventHandling, %Control, 'PageDown')
  #IF(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  %ListPre.ListPageDown(%Control, %ControlFrom)
  #ENDIF
  #ENDIF
#ENDAT
!
!  Page up the list
!
#AT(%ControlPreEventHandling, %Control, 'PageUp')
  #IF(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  %ListPre.ListPageUp(%Control, %ControlFrom)
  #ENDIF
  #ENDIF
#ENDAT
!
!  Scroll to the bottom of the list
!
#AT(%ControlPreEventHandling, %Control, 'ScrollBottom')
  #IF(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  %ListPre.ListScrollBottom(%Control, %ControlFrom)
  #ENDIF
  #ENDIF
#ENDAT
!
!  Scroll down the list
!
#AT(%ControlPreEventHandling, %Control, 'ScrollDown')
  #IF(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  %ListPre.ListScrollDown(%Control, %ControlFrom)
  #ENDIF
  #ENDIF
#ENDAT
!
!  Scroll to the top of the list
!
#AT(%ControlPreEventHandling, %Control, 'ScrollTop')
  #IF(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  %ListPre.ListScrollTop(%Control, %ControlFrom)
  #ENDIF
  #ENDIF
#ENDAT
!
!  Scroll the list based on the thumb button on the slider
!
#AT(%ControlPreEventHandling, %Control, 'ScrollDrag')
  #IF(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  %ListPre.ListScrollDrag(%Control, %ControlFrom)
  #ENDIF
  #ENDIF
#ENDAT
!
!  Scroll up the list
!
#AT(%ControlPreEventHandling, %Control, 'ScrollUp')
  #IF(%Controltype='LIST')
  #SET(%ListPre,'List' & INLIST(%Control, %Control))
  #IF(INLIST(%Control, %CheckList))
  %ListPre.ListScrollUp(%Control, %ControlFrom)
  #ENDIF
  #ENDIF
#ENDAT
